#!/bin/sh

dir=`dirname $0`

echo "SysAid Agent for Linux version 7.0.01" 

if [ $# -ne "3" ]
then
  echo "Usage: `basename $0` <URL> <Account ID> <Serial> "
  exit 1
fi

lshwExistance=`lshw -version`
lshwExistance=`echo "$lshwExistance" | wc -c`

if [ $lshwExistance -eq 1 ]
then
  echo ""
  echo "ERROR: The lshw command is not found. Please install lshw before running the SysAid agent for Linux."
  exit 1
fi

osName=`$dir/distro.sh -n`
osVer=`$dir/distro.sh -r`
osCode=`$dir/distro.sh -c`
osKernel=`uname -sr`

if [ "$osName" = "Debian GNU/Linux" ]; then
  OUTPUTsoftware=`dpkg-query -W -f='${Package}|||${Version}||| ||| |||${Maintainer}\n'`
else
  OUTPUTsoftware=`rpm -qa --qf "%{Name}|||%{VERSION}|||%{SUMMARY}|||%{INSTALLTIME}|||%{VENDOR}\n"`
fi

OUTPUTlshw=`lshw -xml`
OUTPUTmeminfo=`cat /proc/meminfo`
OUTPUTcpuuinfo=`cat /proc/cpuinfo`
OUTPUTpartitions=`cat /proc/partitions`

echo "**********lshw-begin**********" > /tmp/sysaid-post.out
echo "$OUTPUTlshw" >> /tmp/sysaid-post.out
echo "**********lshw-end**********" >> /tmp/sysaid-post.out
echo "**********meminfo-begin**********" >> /tmp/sysaid-post.out
echo "$OUTPUTmeminfo" >> /tmp/sysaid-post.out
echo "**********meminfo-end**********" >> /tmp/sysaid-post.out
echo "**********cpuinfo-begin**********" >> /tmp/sysaid-post.out
echo "$OUTPUTcpuuinfo" >> /tmp/sysaid-post.out
echo "**********cpuinfo-end**********" >> /tmp/sysaid-post.out
echo "**********software-begin**********" >> /tmp/sysaid-post.out
echo "$OUTPUTsoftware" >> /tmp/sysaid-post.out
echo "**********software-end**********" >> /tmp/sysaid-post.out
echo "**********partitions-begin**********" >> /tmp/sysaid-post.out
echo "$OUTPUTpartitions" >> /tmp/sysaid-post.out
echo "**********partitions-end**********" >> /tmp/sysaid-post.out

echo " "
echo "Inventory information collecting completed. Sending the output to the server..."

wget -q --header='Content-Type: text/xml' --post-file=/tmp/sysaid-post.out --output-document=/tmp/wget-response.out "$1/lshw?accountID=$2&serial=$3&osName=$osName&osVer=$osVer&osCode=$osCode&osKernel=$osKernel"
echo "Done."

rm -rf /tmp/sysaid-post.out /tmp/wget-response.out
